

#include <p18f4520.h>
#include <delays.h>

#define WP      PORTBbits.RB4    // AT24C256 .S  WP
#define SDA     PORTBbits.RB2
#define SCL		PORTBbits.RB3
#define SDA_In  TRISBbits.TRISB2 = 1  // changed input pin for SDA; 
#define SDA_Out TRISBbits.TRISB2 = 0  //
#define SCL_Out TRISBbits.TRISB3 = 0



 /*  Inter IC Bus
    frequency=4Mhz,T=1us

*************************************************************/

 void sta(void)
       {
		SDA_In;
		Nop();
		SDA=1;
        Nop();
        SCL=1;
        Nop();
        Nop();
        Nop();
		SDA_Out;
        Nop();
        Nop();
        Nop();
        SDA=0;
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        SCL=0;
        Nop();
        Nop();
       }
/****
ӻλж,sda½.
****/

//******************************
   void stop(void)
        {
		SDA_Out;
         SDA=0;
         Nop();
         SCL=1;
         Nop();
         Nop();
         Nop();
		SDA_In;
         Nop();
         Nop();
         SDA=1;
         Nop();
         Nop();
         Nop();
         Nop();
         Nop();
         Nop();
         Nop();
         SCL=1;
        }
//-------------------------------

//****************************Ӧź



 void mack(void)
      {SDA=0;
       Nop();
       Nop();
       Nop();
       Nop();
       SCL=1;
       Nop();
       Nop();
       Nop();
       Nop();
       Nop();
       SCL=0;
       Nop();
       SDA=1;
       }
//***************************** Ӧź

  void mnack(void)
       {SDA=1;
        Nop();
        SCL=1;
        Nop();
        Nop();
        Nop();
        Nop();
        Nop();
        SCL=0;
        Nop();
        SDA=0;
        }

//******************************* ǷӦźţз=1,񷵻0;
unsigned char  cack(void)
       {
		SDA_Out;
		Nop();
		Nop();
         SDA=0;
		  Nop();
         Nop();
		SDA_In;
		Nop();
		Nop();

         SCL=1;
	Delay10TCYx(1);
         Nop();
         Nop();
         Nop();
         Nop();
         Nop();
		              // SDAΪ.
		 Nop();
         Nop();
         if (SDA==1)
            {
			Delay10TCYx(1);
			SCL=0;
		//	SDA_Out;        // 
			return(1);
			}
          SCL=0;
		//  SDA_Out;         //
		return(0);
         }
//****************************һֽڣһֽڡ


unsigned char rdbyt(void)
       {unsigned char i2c_r0=8,i2c_w=0;

       do{ SDA_Out;
		   SDA=1;
           Nop();
           Nop();
           Nop();
           Nop();
           Nop();
           Nop();
           SCL=1;
           Nop();
           Nop();
			SDA_In;
           if (SDA)
               {i2c_w<<=1;
                i2c_w++;
               }
            else
               {i2c_w<<=1;
               }
             SCL=0;
             i2c_r0--;
            }while(i2c_r0!=0);
            SCL=0;
            Nop();
            Nop();
         return(i2c_w);

         }

//******************************************

 void wrbyt(unsigned char w)
      {unsigned char i;
        i=0x08;
       do{ SCL=0;
          
           Nop();
           Nop();
          // SDA= (bit)(w&0x80);
           if((w&0x80)==0x80)     ////**** λ1****
                {
				SDA_In;
				SDA=1;
                }
           else
                {
				SDA_Out;
				SDA=0;
                }
           w=w<<1;
           Nop();
           SCL=1;
           Nop();
           Nop();
           Nop();
		 Nop();
           Nop();
           Nop();
           Nop();
           Nop();
           SCL=0;

           i--;
         }while(i!=0);

      }
//*************************************************
//**************************************************

    /********* at24c256ĲԳ

            ah=0;al=0x01;i=0x01;
             j=0x01;
              do
                    { Write_Byte(ah,al,i);
                      al++;
                      i++;
                      j--;
                    }while(j!=0);


                   // дeepromҪһʱ
                   ah=0;al=0x01;
                   j=0x01;
                   do
                         {i=Read_Byte(ah,al);
                          j--;
                         }while(j!=0);


//********************************************************/

 /*****************************************
** : Write a byte
** 䡡: eep_adh,eep_adl,eep_data
**  eep_data   Ҫдֽ
**  eep_adh   Ҫд24c256ĸ8λַ
**  eep_adl   Ҫд24c256ĵ8λַ
** 䡡: no
** :a byte д24c256
** ȫֱ:
** ģ:ģI2C BUS SUB
** :lijun  leejun@qingdaonews.com
** ա:2002/6/3

//*********************************дһֽ***/


void Write_Byte(unsigned int addr,unsigned char eep_data)
     {unsigned char i,eep_al,eep_ah;
	
      WP=0;
	eep_al = addr &0x00ff;
	eep_ah = (addr>>8)& 0x00ff; 
      sta();
      i=0xa0;
      wrbyt(i);
      cack();

      wrbyt(eep_ah);
      cack();
      wrbyt(eep_al);
      cack();
      wrbyt(eep_data);
      cack();
      stop();
      WP=1;
      }
/*******************************************/
/*****************************************
** :ReadAt24c256
** 䡡: eep_adh,eep_adl
**     eep_adh   Ҫд24c256ĸ8λַ
**     eep_adl   Ҫд24c256ĵ8λַ
** 䡡: eep_data  Ҫֽڡ
** :a byte 24c256
** ȫֱ:
** ģ:ģI2C BUS SUB
** :lijun  leejun@qingdaonews.com
** ա:2002/08/26
** 汾 1.0
******************************************/


unsigned char  ReadAt24c256(unsigned int addr)   // eep_adh,unsigned char eep_adl)
         {unsigned char temp,eep_adh,eep_adl;
			eep_adh = (addr >>8)& 0x00ff;
		eep_adl = addr & 0x00ff;

          sta();
          temp=0xa0;
         // _nop_();
          wrbyt(temp);
          cack();

          wrbyt(eep_adh);
          cack();
          wrbyt(eep_adl);
          cack();

          sta();
          temp =0xa1;
          wrbyt( temp );
          cack();

          temp=rdbyt();
          mnack();
          stop();
          return(temp);
         }
//***************************************************


/*****************************************/
void AllWrite0toAt24c256(void)
{

	unsigned int addr;
	unsigned char i;
	addr = 0;
	do 
		{
		//	do
			//	{
aaa:				Write_Byte(addr,0);
				Delay10TCYx(1000);
				i = 0xdd;
				i =	ReadAt24c256(addr);
				if ( i!=0)
					goto aaa;
			//	}while(i ==0);
		addr++;		
			
		}while(addr < 0x2000);

}
//*****************************************************
